import java.util.Random;


public class DivideInteger extends Function 
{
	int index, addNumber;
	
	public DivideInteger(int index, int addNumber, Environment environment)
	{
		this.index = index;
		this.addNumber= addNumber;
		
		parameters.add(index);
		parameters.add(addNumber);
		this.environment = environment;
	}
	
	@Override
	public void execute()
	{
		if((Integer)parameters.get(1)==0)
			return;
		try 
		{
			int result = environment.getIntegerVariableAt((Integer)parameters.get(0)) / (Integer)parameters.get(1);
			environment.setIntegerVariableAt((Integer)parameters.get(0), result);
		}
		catch (Exception e) 
		{
			e.printStackTrace();
		}
	}

	@Override
	public void setNeighbour(Function neighbour) 
	{
		neighbours.clear();
		if(neighbour != null)
			neighbours.add(neighbour);
	}

	@Override
	public Function deepCopy(Environment newEnvironment) 
	{
		Function copy;
		Function firstFunction = new DivideInteger(index, addNumber, newEnvironment);
		Function current = this;
		copy = firstFunction;
		
		while(current.getNextFunction() != null && firstFunction.getNextFunction() != null)
		{
			firstFunction.setNeighbour(current.getNextFunction().deepCopy(newEnvironment));
			current = current.getNextFunction();
			firstFunction = firstFunction.getNextFunction();
		}
		
		return copy;
	}

	@Override
	public void mutateParameter(Random random, int interval) 
	{
		addNumber += random.nextInt(interval) - interval/2;
		parameters.set(1, addNumber);
	}

}
