
public class ForLoopWithOperation extends ForLoop 
{
	int currentIndex;
	int operator;
	int operand;
	
	// 0 -, 1 *, 2 /
	public ForLoopWithOperation(int depth, int start, int end, Function body, Environment environment, int operator, int operand)
	{
		super(depth,start,end, body, environment);
		this.operator = operator;
		this.operand = operand;
		
		if((operator == 1 || operator == 2) && start==0)
		{
			this.start = 1;
			parameters.set(1, this.start);
			if(operand == 0 || operand == 1)
				this.operand = 2;
		}
	}

	@Override
	public void execute() 
	{
		try 
		{
			currentIndex = (Integer) parameters.get(1); 
			switch(operator)
			{
				case 0:
					while(currentIndex >=  (Integer) parameters.get(2))
					{
						environment.setOwnLoopIndice(currentIndex);
						body.execute();
						currentIndex -= operand;
					}
					break;
				case 1:
					while(currentIndex <=  (Integer) parameters.get(2))
					{
						environment.setOwnLoopIndice(currentIndex);
						body.execute();
						currentIndex *= operand;
					}
					break;
				case 2:
					if (operand == 0)
						operand = 2;
					while(currentIndex >  (Integer) parameters.get(2))
					{
						environment.setOwnLoopIndice(currentIndex);
						body.execute();
						currentIndex /= operand;
					}
					break;
			}

			
			if(neighbours.size() > 0)
				neighbours.get(0).execute();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public Function deepCopy(Environment newEnvironment) 
	{
		Function copy;
		Function firstFunction = new ForLoopWithOperation(depth, start, end, this.body.deepCopy(newEnvironment), newEnvironment, operator, operand);
		Function current = this;
		copy = firstFunction;
		
		while(current.getNextFunction() != null && firstFunction.getNextFunction() != null)
		{
			firstFunction.setNeighbour(current.getNextFunction().deepCopy(newEnvironment));
			current = current.getNextFunction();
			firstFunction = firstFunction.getNextFunction();
		}
		
		return copy;
	}


}
