import java.util.LinkedList;
import java.util.Random;

public abstract class Function
{
	LinkedList<Object> parameters = new LinkedList<Object>();
	LinkedList<Function> neighbours = new LinkedList<Function>();
	Environment environment;
	
	public abstract void execute();
	public abstract void setNeighbour(Function neighbour);
	public abstract Function deepCopy(Environment newEnvironment);
	public abstract void mutateParameter(Random random, int interval);
	public Function getNextFunction()
	{
		if(neighbours.size() > 0)
			return neighbours.getLast();
		else return null;
	}
	
	public String toString()
	{
		return this.getClass().getName() + " : " + parameters;
	}
}
