import java.util.Random;


public class IfGreater extends Function 
{
	private int arrayAtIndexOrVariables, first, second, array;
	
	public IfGreater(int arrayAtIndexOrVariables, int first, int second, Environment environment, int array)
	{
		this.arrayAtIndexOrVariables = arrayAtIndexOrVariables;
		this.first = first;
		this.second = second;
		this.array = array;
		
		this.environment = environment;
		
		if(environment.forLoopIndices.size() == 0)
		{
			parameters.add(environment.getIntegerVariableAt(first));
			parameters.add(environment.getIntegerVariableAt(second));
		}
		else	
			switch(arrayAtIndexOrVariables)
			{
				case 0: //array ellement
					parameters.add(environment.getIntegerArrayAt(array)[first]);
					parameters.add(environment.getIntegerArrayAt(array)[second]);
					break;
				case 1: //variables
					parameters.add(environment.getIntegerVariableAt(first));
					parameters.add(environment.getIntegerVariableAt(second));
					break;
			}
		parameters.add(first);
		parameters.add(second);
	}
	
	public void setTFNeighbours(Function True, Function False)
	{
		if(neighbours.size()>0) 
		{
			neighbours.remove(0);
			neighbours.remove(0);
		}
		neighbours.add(0, True);
		neighbours.add(1,False);
	}
	
	public void setNeighbour(Function neighbour)
	{
		if(this.neighbours.size() > 2)
			this.neighbours.remove(2);
		if(neighbour != null)
			this.neighbours.add(neighbour);
	}
	
	@Override
	public void execute()
	{
		try
		{
			Comparable a = (Comparable)parameters.get(0);
			Comparable b = (Comparable)parameters.get(1);
			if(a.compareTo(b)>0)
				neighbours.get(0).execute();
			else
				neighbours.get(1).execute();
			
			if(neighbours.size()==3)
				neighbours.get(2).execute();
		}
		catch(Exception e)
		{
			e.printStackTrace();
			//throw new LoopsException("IfGreaterThen function not working: " + e.getMessage());
		}
	}
	
	public Function getNextFunction()
	{
		if(neighbours.size()==3)
			return neighbours.get(2);
		else
			return null;
	}

	@Override
	public Function deepCopy(Environment newEnvironment) 
	{
		IfGreater copy;
		Function firstFunction = new IfGreater(arrayAtIndexOrVariables, first, second, newEnvironment, array);
		Function current = this;
		copy = (IfGreater) firstFunction;
		
		copy.setTFNeighbours(this.neighbours.get(0).deepCopy(newEnvironment), this.neighbours.get(1).deepCopy(newEnvironment));
		
		while(current.getNextFunction() != null  && firstFunction.getNextFunction() != null)
		{
			firstFunction.setNeighbour(current.getNextFunction().deepCopy(newEnvironment));
			current = current.getNextFunction();
			firstFunction = firstFunction.getNextFunction();
		}
		
		return copy;
	}

	@Override
	public void mutateParameter(Random random, int interval) 
	{
		int fst = first;
		int scnd = second;
		if(random.nextInt(1) == 0)
			fst += random.nextInt(interval);
		else
			scnd += random.nextInt(interval);
		
		IfGreater mutated = new IfGreater(arrayAtIndexOrVariables, fst, scnd, environment, array);
		this.parameters = mutated.parameters;
	}
}