import java.util.LinkedList;
import java.util.Random;


public class Loops 
{
	public static void main(String[] args) 
	{
		int populationSize = 50;
		float mutationFactor = (float) 0.3;
		int mutationInterval = 6;
		int numberOfGenerations = 300;
		int forMinIndex = 0;
		int forMaxIndex = 4;
		int maxFun = 5;
		int tournamentSize = 7;
		
		Random random = new Random();
		
		LinkedList<Integer> variables = new LinkedList<Integer>();
		variables.add(0);
		variables.add(2);
		variables.add(3);
		variables.add(4);
		variables.add(1);
		
		LinkedList<int[]> arrays = new LinkedList<int[]>();
		int[] a = {3,2,1,54,5};
		arrays.add(a);
		
		LinkedList<Environment> population = new LinkedList<Environment>();
		for(int i=0; i < populationSize; i++)
		{
			population.add(new Environment(variables, arrays, forMinIndex, forMaxIndex, maxFun));
		}
		
		for(Environment individual : population)
			individual.fitness = GeneticOperators.sortingFitness(individual);
		
				
		for(int i=0; i < numberOfGenerations; i++)
		{			
			System.out.println("Generation number: " + i);
			
			LinkedList<Environment> tournament = GeneticOperators.tournament(population, tournamentSize, random);
					
			Environment child = tournament.get(2);
			child = GeneticOperators.crossover(tournament.get(0), tournament.get(1), random);
			
			GeneticOperators.mutationOfParameters(mutationFactor, child, random, mutationInterval);
			child.fitness = GeneticOperators.sortingFitness(child);
		}
		
		int maxFitness = population.get(0).fitness;
		int maxIndex = 0;
		
		for(int i=1; i < populationSize; i++)
		{
			if(population.get(i).fitness > maxFitness)
			{
				maxFitness = population.get(i).fitness;
				maxIndex = i;
			}
		}
		
		System.out.println();
		System.out.println("Fitness : " + population.get(maxIndex).fitness);
		System.out.println("Variables : " + variables);

		System.out.println("----------------------------------------------------------");
		System.out.println();
		
		LinkedList<String> print  = printProgram(new LinkedList<String>(), population.get(maxIndex).firstFunction, 0);
		for(String var : print)
			System.out.println(var);

/*		System.out.println();
		System.out.println("----------------------------------------------------------");
		System.out.println();*/
	}
	
	public static LinkedList<String> printProgram(LinkedList<String> functionList, Function function, int indent)
	{
		
		if (function != null) 
		{
			String ind = "";
			for(int i=0; i<indent; i++)
				ind += "\t";
			
			functionList.add(ind + function.toString());
			
			if (function instanceof ForLoop || function instanceof ForLoopWithOperation)
				functionList = printProgram(functionList,((ForLoop) function).body, indent+1);
			
			if (function instanceof IfGreater || function instanceof IfSmaller) 
			{
				int ifIndent = indent + 1;
				functionList = printProgram(functionList, function.neighbours.get(0), ifIndent);
				functionList = printProgram(functionList, function.neighbours.get(1), ifIndent);
			}
			
			functionList = printProgram(functionList, function.getNextFunction(), indent);
		}

		return functionList;
	}

}
